package com.pbsage.util;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

public class HttpUtil {
	private static HttpUtil instance = new HttpUtil();

	private HttpUtil() {

	}

	public static HttpUtil Instance() {
		return instance;
	}

	private HttpClient client = new DefaultHttpClient();

	public String post(String url, Map<String, String> params) throws Exception {
		HttpPost httpost = new HttpPost(url);
		List<NameValuePair> nvps = new ArrayList<NameValuePair>();
		Set<String> keySet = params.keySet();
		for (String key : keySet) {
			nvps.add(new BasicNameValuePair(key, params.get(key)));
		}
		httpost.setEntity(new UrlEncodedFormEntity(nvps, "utf-8"));
		HttpResponse httpResponse = client.execute(httpost);
		InputStream is = httpResponse.getEntity().getContent();
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		int b = -1;
		while ((b = is.read()) != -1) {
			baos.write(b);
		}
		baos.close();
		is.close();

		String result = baos.toString("UTF-8");
		return result;
	}

	public String post(String url, String content) throws Exception {
		HttpPost httpost = new HttpPost(url);
		StringEntity entity = new StringEntity(content, "UTF-8");
		httpost.setEntity(entity);
		entity.setContentType("application/json");
		HttpResponse httpResponse = client.execute(httpost);
		InputStream is = httpResponse.getEntity().getContent();
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		int b = -1;
		while ((b = is.read()) != -1) {
			baos.write(b);
		}
		baos.close();
		is.close();

		String result = baos.toString("UTF-8");
		return result;
	}

	public String get(String url) throws Exception {
		HttpGet httpget = new HttpGet(url);
		// httpget.setHeader(new BasicHeader("Content-type", "text/plain;charset=utf-8"));
		// httpget.setHeader(new BasicHeader("Content-type", "application/json;charset=utf-8"));
		HttpResponse response = client.execute(httpget);
		InputStream is = response.getEntity().getContent();
		ByteArrayOutputStream os = new ByteArrayOutputStream();
		int i = -1;
		while ((i = is.read()) != -1) {
			os.write(i);
		}
		is.close();
		os.close();

		String result = os.toString("UTF-8");
		return result;
	}
}
