package com.persagy.data_dict_tool;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.pbsage.util.Constant;
import com.pbsage.util.HttpUtil;
import com.persagy.util.DataDictUtil;

@SuppressWarnings("unused")
public class DataDictToolMain {
	public static String url = "http://192.168.3.203:8080/";
	public static String projectId = "Pj1101050029";
	public static String url_param = "?projectId=" + projectId + "&appId=datautils";
	// "http://192.168.3.203:8080/dict/funcid/query?projectId=Pj1101080002&appId=datautils"
	public static int floor_count = 2;
	public static int equipment_count = 2;

	public static void main(String[] args) throws Exception {
		// Iterator<String> keyIter = infos.keySet().iterator();
		// while (keyIter.hasNext()) {
		// String key = keyIter.next();
		// infos.get(key);
		// }

		// DataDictScanner.Scan();

		JSONArray systemArray = null;
		JSONArray equipmentArray = null;
		JSONObject classTree = JSON.parseObject(HttpUtil.Instance().get(url + "dict/class"));
		Constant.warn(JSON.toJSONString(classTree, SerializerFeature.WriteMapNullValue));
		// Constant.warn(FastJsonUtil.toFormatString(classTree));
		JSONArray dataArray = (JSONArray) classTree.get("data");
		for (int i = 0; i < dataArray.size(); i++) {
			JSONObject data = (JSONObject) dataArray.get(i);
			String code = (String) data.get("code");
			if (code.equals("system")) {
				systemArray = (JSONArray) data.get("children");
			} else if (code.equals("equipment")) {
				equipmentArray = (JSONArray) data.get("children");
			}
		}

		JSONObject building = null;
		{
			String classCode = "building";
			JSONObject object = DataDictUtil.createObject(classCode, "1¥");
			building = object;
			// DataDictQueryUtil.insert_rel("Gt" + "ArchSubset" + "001", "Pj2Bd", projectId, (String) building.get("id"));
		}
		for (int index_floor = 0; index_floor < floor_count; index_floor++) {
			String classCode = "floor";
			String floor_name = (index_floor + 1) + "";
			JSONObject floor_object = DataDictUtil.createObject(classCode, floor_name);
			DataDictQueryUtil.insert_rel("Gt" + "ArchSubset" + "001", "Bd2Fl", (String) building.get("id"), (String) floor_object.get("id"));

			for (int i = 0; i < equipmentArray.size(); i++) {
				JSONObject equipment_zy = (JSONObject) equipmentArray.get(i);
				String space_name = floor_name + "-" + equipment_zy.get("name") + "-" + "";
				JSONObject space_object = DataDictUtil.createObject("space", space_name);
				DataDictQueryUtil.insert_rel("Gt" + "ArchSubset" + "001", "Fl2Sp", (String) floor_object.get("id"), (String) space_object.get("id"));
				JSONArray syArray = (JSONArray) equipment_zy.get("children");
				for (int ii = 0; ii < syArray.size(); ii++) {
					JSONObject sy = (JSONObject) syArray.get(ii);
					String code_sy = ((String) sy.get("code")).substring("equipment-".length());
					String sy_name = floor_name + "-" + sy.get("name");
					JSONObject object_sy = DataDictUtil.createObject(code_sy, sy_name);
					DataDictQueryUtil.insert_rel("Gt" + "MechInArch" + "001", "Sy2Sp", (String) object_sy.get("id"), (String) space_object.get("id"));
					JSONArray objectTypeArray = (JSONArray) sy.get("children");
					for (int iii = 0; iii < objectTypeArray.size(); iii++) {
						JSONObject objectType = (JSONObject) objectTypeArray.get(iii);
						String code_eq = (String) objectType.get("code");
						for (int iiii = 0; iiii < equipment_count; iiii++) {
							String eq_name = sy_name + "-" + objectType.getString("name") + "-" + (iiii + 1);
							JSONObject object_eq = DataDictUtil.createObject(code_eq, eq_name);
							DataDictQueryUtil.insert_rel("Gt" + "MechSubset" + "001", "Sy2Eq", (String) object_sy.get("id"),
									(String) object_eq.get("id"));
							DataDictQueryUtil.insert_rel("Gt" + "MechInArch" + "001", "Eq2Sp", (String) object_eq.get("id"),
									(String) space_object.get("id"));
						}
					}
				}
			}
		}
	}
}
