package com.persagy.data_dict_tool.v2;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.pbsage.util.Constant;
import com.pbsage.util.HttpUtil;
import com.persagy.util.ExcelSheet;
import com.persagy.util.ExcelUtil;

public class DataDictCheck {
	public static String mode = "check";
	public static String projectId = "Pj4403070003";
	public static String groupCode = "WD";

	public static void main(String[] args) throws Exception {
		int index = 0;
		mode = args[index++];
		projectId = args[index++];
		groupCode = args[index++];

		Scan_dict();
	}

	public static void Scan_dict() throws Exception {
		JSONObject classParam = new JSONObject();
		classParam.put("criteria", new JSONObject());
		JSONObject classTree = JSON
				.parseObject(HttpUtil.Instance().post(Constant.data_middle_url + "rwd/def/class?projectId=" + projectId + "&groupCode=" + groupCode,
						JSON.toJSONString(classParam, SerializerFeature.WriteMapNullValue)));
		JSONArray dataArray = (JSONArray) classTree.get("data");
		Map<String, List<String>> system2objectMap = new HashMap<String, List<String>>();
		Map<String, String> type2nameMap = new HashMap<String, String>();
		Map<String, String> system2nameMap = new HashMap<String, String>();
		for (int i = 0; i < dataArray.size(); i++) {
			JSONObject data = (JSONObject) dataArray.get(i);
			String objType = (String) data.get("objType");
			if (objType == null || objType.length() == 0) {
				continue;
			}
			String majorCode = (String) data.get("majorCode");
			if (majorCode == null || majorCode.length() == 0) {
				continue;
			}
			if (!objType.equals("system")) {
				continue;
			}
			String classCode = (String) data.get("code");
			String name = (String) data.get("name");
			system2nameMap.put(classCode, name);
		}
		for (int i = 0; i < dataArray.size(); i++) {
			JSONObject data = (JSONObject) dataArray.get(i);
			String objType = (String) data.get("objType");
			if (objType == null || objType.length() == 0) {
				continue;
			}
			String majorCode = (String) data.get("majorCode");
			if (majorCode == null || majorCode.length() == 0) {
				continue;
			}
			if (!objType.equals("equipment")) {
				continue;
			}
			// if (!objType.equals("system") && !objType.equals("equipment") && !objType.equals("space")) {
			//
			// }
			// if (!classCode.equals("SETDLS")) {
			// continue;
			// }
			String classCode = (String) data.get("code");
			String name = (String) data.get("name");
			type2nameMap.put(classCode, name);
			String system = classCode.substring(0, 4);
			system2objectMap.putIfAbsent(system, new ArrayList<String>());
			system2objectMap.get(system).add(classCode);
		}
		for (String system : system2objectMap.keySet()) {
			List<String> typeList = system2objectMap.get(system);
			Map<String, ExcelSheet> dyMap = new HashMap<String, ExcelSheet>();
			int total_count = 0;
			for (String classCode : typeList) {
				ExcelSheet report = Scan_classCode(classCode);
				int count = report.contentListList.size() > 3 ? (report.contentListList.size() - 4) : 0;
				String sheetName = type2nameMap.get(classCode) + "-" + (count > 0 ? classCode + "-" + count : classCode);
				dyMap.put(sheetName, report);
				Constant.info(classCode + "\t" + count);
				total_count += count;
			}
			ExcelUtil.Write(projectId + "/" + groupCode + "-" + projectId + "-" + system2nameMap.get(system) + "-" + system
					+ (total_count > 0 ? "-" + total_count : "") + ".xlsx", dyMap);
		}
	}

	public static ExcelSheet Scan_classCode(String classCode) throws Exception {
		Constant.warn(classCode);
		JSONArray infoArray;
		Map<String, JSONObject> infoMap = new HashMap<String, JSONObject>();
		List<String> firstTagList = new ArrayList<String>();
		Map<String, List<String>> firstTagMap = new HashMap<String, List<String>>();
		Map<String, List<String>> tag2InfosMap = new HashMap<String, List<String>>();
		Map<String, String> info2nameMap = new HashMap<String, String>();
		{
			JSONObject criteria = new JSONObject();
			criteria.put("classCode", classCode);
			JSONObject classParam = new JSONObject();
			classParam.put("criteria", criteria);
			JSONObject classTree = JSON.parseObject(
					HttpUtil.Instance().post(Constant.data_middle_url + "rwd/def/funcid?projectId=" + projectId + "&groupCode=" + groupCode,
							JSON.toJSONString(classParam, SerializerFeature.WriteMapNullValue)));
			infoArray = (JSONArray) classTree.get("data");
			for (int i = 0; i < infoArray.size(); i++) {
				JSONObject info = (JSONObject) infoArray.get(i);
				String code = (String) info.get("code");
				String name = (String) info.get("name");
				String firstTag = (String) info.get("firstTag");
				String secondTag = (String) info.get("secondTag");
				infoMap.put(code, info);
				info2nameMap.put(code, name);
				if (firstTag != null) {
					if (!firstTagMap.containsKey(firstTag)) {
						firstTagList.add(firstTag);
						firstTagMap.put(firstTag, new ArrayList<String>());
					}
					if (secondTag != null) {
						boolean exist = false;
						for (String ttt : firstTagMap.get(firstTag)) {
							if (ttt.equals(secondTag)) {
								exist = true;
								break;
							}
						}
						if (!exist) {
							firstTagMap.get(firstTag).add(secondTag);
						}
					}

					if (!tag2InfosMap.containsKey(firstTag + ":" + secondTag)) {
						tag2InfosMap.put(firstTag + ":" + secondTag, new ArrayList<String>());
					}
					tag2InfosMap.get(firstTag + ":" + secondTag).add(code);
				}
			}
		}
		JSONArray objectArray;
		{
			JSONObject criteria = new JSONObject();
			criteria.put("classCode", classCode);
			criteria.put("valid", 1);
			JSONObject classParam = new JSONObject();
			classParam.put("criteria", criteria);
			JSONObject classTree = JSON.parseObject(HttpUtil.Instance().post(
					Constant.data_middle_url + "rwd/instance/object/query?projectId=" + projectId + "&groupCode=" + groupCode,
					JSON.toJSONString(classParam, SerializerFeature.WriteMapNullValue)));
			objectArray = (JSONArray) classTree.get("data");
			if (objectArray == null) {
				objectArray = new JSONArray();
			}
		}

		ExcelSheet report = new ExcelSheet();
		List<String> titleList2 = new ArrayList<String>();
		List<String> titleList3 = new ArrayList<String>();
		List<String> titleList4 = new ArrayList<String>();
		report.contentListList.add(titleList2);
		report.contentListList.add(titleList4);
		report.contentListList.add(titleList3);
		report.titleColList.add("id");
		report.titleColList.add("localId");
		report.titleColList.add("localName");
		titleList2.add("id");
		titleList2.add("localId");
		titleList2.add("localName");
		titleList3.add("id");
		titleList3.add("localId");
		titleList3.add("localName");
		titleList4.add("id");
		titleList4.add("localId");
		titleList4.add("localName");
		for (String firstTag : firstTagList) {
			List<String> secondTagList = firstTagMap.get(firstTag);
			if (secondTagList == null || secondTagList.size() == 0) {
				String secondTag = null;
				List<String> infos = tag2InfosMap.get(firstTag + ":" + secondTag);
				for (String info : infos) {
					report.titleColList.add(firstTag);
					titleList2.add(secondTag);
					titleList3.add(info);
				}
			} else {
				for (String secondTag : secondTagList) {
					List<String> infos = tag2InfosMap.get(firstTag + ":" + secondTag);
					for (String info : infos) {
						report.titleColList.add(firstTag);
						titleList2.add(secondTag);
						titleList3.add(info);
						titleList4.add(info2nameMap.get(info));
					}
				}
			}
		}
		Map<String, IntWrapper> countMap = new HashMap<String, IntWrapper>();
		for (String infoCode : titleList3) {
			countMap.put(infoCode, new IntWrapper());
		}
		for (int index = 0; index < objectArray.size(); index++) {
			JSONObject object = (JSONObject) objectArray.get(index);
			List<String> contentList = new ArrayList<String>();
			report.contentListList.add(contentList);
			for (String infoCode : titleList3) {
				Object infoValue = object.get(infoCode);
				contentList.add(infoValue == null ? "  " : infoValue.toString());
				countMap.get(infoCode).value = countMap.get(infoCode).value + (infoValue == null ? 0 : 1);
			}
		}

		if (report.contentListList.size() > 3) {
			List<String> titleList5 = new ArrayList<String>();
			for (String infoCode : titleList3) {
				titleList5.add(countMap.get(infoCode).value > 0 ? "" + countMap.get(infoCode).value : "  ");
			}
			report.contentListList.add(3, titleList5);
		}

		return report;
	}
}
