package com.persagy.data_dict_tool.v2;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.pbsage.util.Constant;
import com.pbsage.util.HttpUtil;

//ӡͽṹ
public class DataDictPrintTree {
	public static String url = "http://39.102.54.110:8082/rwd/";

	public static void main(String[] args) throws Exception {
		Scan_dict();
	}

	public static void Scan_dict() throws Exception {
		JSONObject classParam = new JSONObject();
		classParam.put("criteria", new JSONObject());
		JSONObject classTree = JSON
				.parseObject(HttpUtil.Instance().post(url + "def/class", JSON.toJSONString(classParam, SerializerFeature.WriteMapNullValue)));
		// Constant.warn(JSON.toJSONString(classTree, SerializerFeature.WriteMapNullValue));
		// Constant.warn(FastJsonUtil.toFormatString(classTree));
		JSONArray dataArray = (JSONArray) classTree.get("data");

		print(dataArray);
	}

	public static void print(JSONArray dataArray) throws Exception {
		JSONObject result = new JSONObject();

		Map<String, String> systemNameMap = new HashMap<String, String>();
		for (int i = 0; i < dataArray.size(); i++) {
			JSONObject data = (JSONObject) dataArray.get(i);
			String objType = (String) data.get("objType");
			if (objType == null || (!objType.equals("equipment") && !objType.equals("system"))) {
				continue;
			}
			String name = (String) data.get("name");
			String code = (String) data.get("code");
			String systemCode = (String) data.get("systemCode");
			if (systemCode == null) {
				systemNameMap.put(code, name);
			}
		}

		String[] systemNames = systemNameMap.keySet().toArray(new String[0]);
		Arrays.sort(systemNames);
		for (String systemName : systemNames) {
			Constant.warn(systemName + "," + systemNameMap.get(systemName));
		}

		for (int i = 0; i < dataArray.size(); i++) {
			JSONObject data = (JSONObject) dataArray.get(i);
			String objType = (String) data.get("objType");
			if (objType == null || (!objType.equals("equipment") && !objType.equals("system"))) {
				continue;
			}

			String name = (String) data.get("name");
			String code = (String) data.get("code");
			String majorCode = (String) data.get("majorCode");
			String systemCode = (String) data.get("systemCode");
			if (code == null || majorCode == null) {
				continue;
			}

			if (!result.containsKey(majorCode)) {
				result.put(majorCode, new JSONObject());
			}
			JSONObject resultItem = (JSONObject) result.get(majorCode);

			if (systemCode != null) {
				String systemName = systemNameMap.get(systemCode);
				if (!resultItem.containsKey(systemCode + "-" + systemName)) {
					resultItem.put(systemCode + "-" + systemName, new JSONObject());
				}
				JSONObject resultItemItem = (JSONObject) resultItem.get(systemCode + "-" + systemName);
				resultItemItem.put(code + "-" + name, true);
			}
		}
		Constant.warn(result.toJSONString());
	}
}
