package com.persagy.data_dict_tool.v2;

import java.io.File;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.pbsage.util.Constant;
import com.pbsage.util.HttpUtil;
import com.persagy.util.DataDictUtil;
import com.persagy.util.ExcelSheet;
import com.persagy.util.ExcelUtil;

public class DataDict_generate {
	public static String mode = "generate";
	public static String projectId = "Pj4403070003";
	public static String groupCode = "WD";
	// public static String projectId = "Pj4403050019";
	// public static String groupCode = "ZS";
	public static boolean only_print = true;
	public static boolean force = false;
	public static String filename = null;

	public static boolean point_use_localId = false;

	public static Map<String, Map<String, Boolean>> systemMapMap = new HashMap<String, Map<String, Boolean>>();
	public static Map<String, Map<String, Boolean>> equipmentMapMap = new HashMap<String, Map<String, Boolean>>();
	public static Map<String, Map<String, Boolean>> wdequipmentMapMap = new HashMap<String, Map<String, Boolean>>();

	public static void main(String[] args) throws Exception {
		int index = 0;
		mode = args[index++];
		projectId = args[index++];
		groupCode = args[index++];
		only_print = args[index++].equalsIgnoreCase("print") ? true : false;
		while (index < args.length) {
			if (args[index].equalsIgnoreCase("force")) {
				force = true;
			}
			if (args[index].startsWith("-file:")) {
				filename = args[index].substring("-file:".length());
			}
			index++;
		}

		File[] files;
		if (filename == null) {
			File dir = new File(Constant.GetPath() + "/info_code-" + groupCode);
			if (!dir.exists()) {
				Constant.warn(Constant.GetPath() + "/info_code-" + groupCode + "\t" + " dont exist");
				return;
			}
			files = dir.listFiles();
		} else {
			files = new File[1];
			File fileInner = new File(Constant.GetPath() + "/" + filename);
			if (!fileInner.exists()) {
				Constant.warn(Constant.GetPath() + "/" + filename + "\t" + " dont exist");
				return;
			}
			files[0] = fileInner;
		}

		for (File file : files) {
			if (!file.isFile()) {
				continue;
			}

			Constant.warn(file.getName());
			ExcelSheet ExcelSheet = ExcelUtil.ReadSheet_frist(file.getPath(), true);
			int index_1 = -1;
			int index_2 = -1;
			int index_2_2 = -1;
			int index_3 = -1;
			for (int i = 0; i < ExcelSheet.titleColList.size(); i++) {
				String titleCol = ExcelSheet.titleColList.get(i);
				if (titleCol == null) {
					continue;
				}
				if (titleCol.equals("ϵͳ")) {
					index_1 = i;
				}
				if (titleCol.equals("豸ͱ")) {
					index_2 = i;
				}
				if (titleCol.equals("豸ͱ")) {
					index_2_2 = i;
				}
				if (titleCol.equals("Ϣ")) {
					index_3 = i;
				}
			}
			for (int i = 0; i < ExcelSheet.contentListList.size(); i++) {
				String content_1 = ExcelUtil.getContentInner(ExcelSheet, index_1, i);
				String content_2 = ExcelUtil.getContentInner(ExcelSheet, index_2, i);
				String content_2_2 = ExcelUtil.getContentInner(ExcelSheet, index_2_2, i);
				String content_5 = ExcelUtil.getContentInner(ExcelSheet, index_3, i);
				if (content_1 == null && content_2 == null && content_2_2 == null || content_5 == null) {
					continue;
				}

				if (content_2_2 != null && content_2_2.length() > 0) {
					if (!wdequipmentMapMap.containsKey(content_2_2)) {
						wdequipmentMapMap.put(content_2_2, new HashMap<String, Boolean>());
					}
					wdequipmentMapMap.get(content_2_2).put(content_5.toLowerCase(), true);
				} else if (content_2 != null && content_2.length() > 0) {
					if (!equipmentMapMap.containsKey(content_2)) {
						equipmentMapMap.put(content_2, new HashMap<String, Boolean>());
					}
					equipmentMapMap.get(content_2).put(content_5.toLowerCase(), true);
				} else {
					if (!systemMapMap.containsKey(content_1)) {
						systemMapMap.put(content_1, new HashMap<String, Boolean>());
					}
					systemMapMap.get(content_1).put(content_5.toLowerCase(), true);
				}
			}

			String[] systemCodes = systemMapMap.keySet().toArray(new String[0]);
			Arrays.sort(systemCodes);
			for (String classCode : systemCodes) {
				Scan(classCode, null);
			}
			String[] equipmentCodes = equipmentMapMap.keySet().toArray(new String[0]);
			Arrays.sort(equipmentCodes);
			for (String classCode : equipmentCodes) {
				if (classCode.equals("equipment") || classCode.equals("system")) {
					String objType = classCode;
					JSONObject classParam = new JSONObject();
					JSONObject criteria = new JSONObject();
					criteria.put("objType", objType);
					classParam.put("criteria", criteria);
					JSONObject classTree = JSON.parseObject(
							HttpUtil.Instance().post(Constant.data_middle_url + "rwd/def/class?projectId=" + projectId + "&groupCode=" + groupCode,
									JSON.toJSONString(classParam, SerializerFeature.WriteMapNullValue)));
					JSONArray dataArray = (JSONArray) classTree.get("data");
					for (int i = 0; i < dataArray.size(); i++) {
						JSONObject data = (JSONObject) dataArray.get(i);
						String classCodeInner = (String) data.get("code");
						if (classCodeInner.equals(objType)) {
							continue;
						}
						Scan(classCodeInner, null);
					}
				} else {
					Scan(classCode, null);
				}
			}
			String[] wdequipmentCodes = wdequipmentMapMap.keySet().toArray(new String[0]);
			Arrays.sort(wdequipmentCodes);
			for (String classCode : wdequipmentCodes) {
				Scan(null, classCode);
			}
		}
	}

	public static void Scan(String classCode_ori, String wdCode) throws Exception {
		Pattern pattern = Pattern.compile("[0-9]{1,}[-][0-9]{1,}");
		Map<String, Boolean> tagMap = new HashMap<String, Boolean>();

		long count = -1;
		JSONArray objectArray = null;
		{
			JSONObject criteria = new JSONObject();
			if (wdCode != null) {
				criteria.put("wdCode", wdCode);
			} else {
				criteria.put("classCode", classCode_ori);
			}
			JSONObject classParam = new JSONObject();
			classParam.put("criteria", criteria);
			JSONObject classTree = JSON.parseObject(HttpUtil.Instance().post(
					Constant.data_middle_url + "rwd/instance/object/query?projectId=" + projectId + "&groupCode=" + groupCode,
					JSON.toJSONString(classParam, SerializerFeature.WriteMapNullValue)));
			count = (Integer) classTree.get("count");
			Constant.warn(classCode_ori + "\t" + wdCode + "\t" + count);
			objectArray = (JSONArray) classTree.get("data");
		}

		if (objectArray == null || objectArray.size() == 0) {
			return;
		}
		String classCode;
		{
			JSONObject object_0 = (JSONObject) objectArray.get(0);
			classCode = object_0.getString("classCode");
		}
		JSONArray infoArray;
		{
			JSONObject criteria = new JSONObject();
			criteria.put("classCode", classCode);
			JSONObject classParam = new JSONObject();
			classParam.put("criteria", criteria);
			JSONObject classTree = JSON.parseObject(
					HttpUtil.Instance().post(Constant.data_middle_url + "rwd/def/funcid?projectId=" + projectId + "&groupCode=" + groupCode,
							JSON.toJSONString(classParam, SerializerFeature.WriteMapNullValue)));
			infoArray = (JSONArray) classTree.get("data");
		}
		if (infoArray != null && objectArray != null) {
			JSONArray addInfoArray = new JSONArray();
			for (int i = 0; i < objectArray.size(); i++) {
				JSONObject object = (JSONObject) objectArray.get(i);
				String id = (String) object.get("id");
				String localId = (String) object.get("localId");
				String localName = (String) object.get("localName");
				JSONObject add_infos = new JSONObject();
				for (int ii = 0; ii < infoArray.size(); ii++) {
					JSONObject info = (JSONObject) infoArray.get(ii);
					String firstTag = (String) info.get("firstTag");
					String secondTag = (String) info.get("secondTag");
					String info_code = (String) info.get("code");
					if (!tagMap.containsKey(firstTag + "-" + secondTag)) {
						tagMap.put(firstTag + "-" + secondTag, true);
					}

					boolean valid = false;
					if (wdCode != null) {
						if (wdequipmentMapMap.containsKey(wdCode) && wdequipmentMapMap.get(wdCode).containsKey(info_code.toLowerCase())
								|| wdequipmentMapMap.containsKey(wdCode.substring(2))
										&& wdequipmentMapMap.get(wdCode.substring(2)).containsKey(info_code.toLowerCase())) {
							valid = true;
						}
					} else {
						if (systemMapMap.containsKey(classCode) && systemMapMap.get(classCode).containsKey(info_code.toLowerCase())
								|| systemMapMap.containsKey(classCode.substring(2))
										&& systemMapMap.get(classCode.substring(2)).containsKey(info_code.toLowerCase())) {
							valid = true;
						}
						if (equipmentMapMap.containsKey(classCode) && equipmentMapMap.get(classCode).containsKey(info_code.toLowerCase())
								|| equipmentMapMap.containsKey(classCode.substring(2))
										&& equipmentMapMap.get(classCode.substring(2)).containsKey(info_code.toLowerCase())) {
							valid = true;
						}
					}
					if (equipmentMapMap.containsKey("equipment") && equipmentMapMap.get("equipment").containsKey(info_code.toLowerCase())) {
						valid = true;
					}

					if (valid) {
						String infoValue = null;
						String id_cut = id.substring(id.length() - 8);
						if (DataDictUtil.getInfoType(info) == 1) {
							infoValue = (point_use_localId ? classCode + "_" + localId + "_" + info_code + "-" + 901
									: classCode + "_" + id_cut + "_" + info_code + "-" + 901);
						} else if (DataDictUtil.getInfoType(info) == 2) {
							infoValue = (point_use_localId ? classCode + "_" + localId + "_" + info_code + "-" + 903
									: classCode + "_" + id_cut + "_" + info_code + "-" + 903);
						}
						if (infoValue != null) {
							Object info_value = object.get(info_code);
							if (info_value != null) {
								if (force) {
									Constant.info(infoValue);
									add_infos.put(info_code, infoValue);
								} else {
									if (infoValue.equals(info_value)) {
										Constant.info(infoValue + "\t\t\t\t" + "exist");
									} else {
										Matcher matcher = pattern.matcher(info_value.toString());
										if (matcher.matches()) {
											Constant.info(infoValue + "\t\t\t\t" + info_value);
										} else {
											Constant.info(infoValue + "\t\t\t\t" + info_value);
										}
									}
								}
							} else {
								Constant.info(infoValue);
								add_infos.put(info_code, infoValue);
							}
						}
					}
				}
				if (add_infos.size() > 0) {
					Constant.warn(classCode + "\t" + wdCode + "\t" + localId + "\t" + localName + "\t" + add_infos.toJSONString());
					add_infos.put("id", id);
					if (!only_print) {
						addInfoArray.add(add_infos);
						if (addInfoArray.size() >= 100) {
							updateArray(addInfoArray);
							addInfoArray.clear();
						}
					}
				}
			}
			if (addInfoArray.size() > 0) {
				updateArray(addInfoArray);
				addInfoArray.clear();
			}
		}
	}

	public static void updateArray(JSONArray postJSON) throws Exception {
		JSONObject classTree = JSON.parseObject(
				HttpUtil.Instance().post(Constant.data_middle_url + "rwd/instance/object/update?projectId=" + projectId + "&groupCode=" + groupCode,
						JSON.toJSONString(postJSON, SerializerFeature.WriteMapNullValue)));
		String result = (String) classTree.get("result");
		if (!result.equals("success")) {
			Constant.warn(result + "\t" + JSON.toJSONString(postJSON, SerializerFeature.WriteMapNullValue));
		}
	}

	public static void update(JSONObject param) throws Exception {
		JSONArray postJSON = new JSONArray();
		postJSON.add(param);
		JSONObject classTree = JSON.parseObject(
				HttpUtil.Instance().post(Constant.data_middle_url + "rwd/instance/object/update?projectId=" + projectId + "&groupCode=" + groupCode,
						JSON.toJSONString(postJSON, SerializerFeature.WriteMapNullValue)));
		String result = (String) classTree.get("result");
		if (!result.equals("success")) {
			Constant.warn(result + "\t" + JSON.toJSONString(param, SerializerFeature.WriteMapNullValue));
		}
	}

	public static void update(String id, String infoCode, Object infoValue) throws Exception {
		JSONArray param = new JSONArray();
		JSONObject criteria = new JSONObject();
		criteria.put("id", id);
		criteria.put(infoCode, infoValue);
		param.add(criteria);
		JSONObject classTree = JSON.parseObject(
				HttpUtil.Instance().post(Constant.data_middle_url + "rwd/instance/object/update?projectId=" + projectId + "&groupCode=" + groupCode,
						JSON.toJSONString(param, SerializerFeature.WriteMapNullValue)));
		String result = (String) classTree.get("result");
		if (!result.equals("success")) {
			Constant.warn(id + "\t" + infoCode + "\t" + infoValue + "\t" + result);
		}
	}

	public static void print(JSONArray dataArray, String propertyName) {
		Constant.warn(propertyName + " :");
		Map<String, Boolean> objTypeMap = new HashMap<String, Boolean>();
		for (int i = 0; i < dataArray.size(); i++) {
			JSONObject data = (JSONObject) dataArray.get(i);
			String objType = (String) data.get(propertyName);
			if (objType == null || objType.length() == 0) {
				continue;
			}
			if (!objTypeMap.containsKey(objType)) {
				objTypeMap.put(objType, true);
				Constant.warn(objType);
			}
		}
	}
}
