package com.persagy.data_dict_tool.v2;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.pbsage.util.Constant;
import com.pbsage.util.HttpUtil;

public class DataDict_remove {
	public static String mode = "remove";
	public static String projectId = "Pj4403070003";
	public static String groupCode = "WD";
	// public static String projectId = "Pj4403050019";
	// public static String groupCode = "ZS";
	public static boolean only_print = true;
	public static boolean all_point = false;

	public static boolean point_use_localId = false;

	public static void main(String[] args) throws Exception {
		int index = 0;
		mode = args[index++];
		projectId = args[index++];
		groupCode = args[index++];
		only_print = args[index++].equalsIgnoreCase("print") ? true : false;
		while (index < args.length) {
			if (args[index].startsWith("-all:")) {
				all_point = args[index].substring("-all:".length()).equalsIgnoreCase("true") ? true : false;
			}
			index++;
		}

		Scan_dict();
	}

	public static void Scan_dict() throws Exception {
		JSONObject classParam = new JSONObject();
		classParam.put("criteria", new JSONObject());
		JSONObject classTree = JSON
				.parseObject(HttpUtil.Instance().post(Constant.data_middle_url + "rwd/def/class?projectId=" + projectId + "&groupCode=" + groupCode,
						JSON.toJSONString(classParam, SerializerFeature.WriteMapNullValue)));
		// Constant.warn(JSON.toJSONString(classTree, SerializerFeature.WriteMapNullValue));
		// Constant.warn(FastJsonUtil.toFormatString(classTree));
		JSONArray dataArray = (JSONArray) classTree.get("data");

		// print(dataArray, "objType");
		// print(dataArray, "majorCode");
		// print(dataArray, "systemCode");
		// print(dataArray, "code");
		// print(dataArray, "type");

		String[] classCodes = new String[dataArray.size()];
		for (int i = 0; i < dataArray.size(); i++) {
			JSONObject data = (JSONObject) dataArray.get(i);
			String code = (String) data.get("code");
			classCodes[i] = code;
		}
		Arrays.sort(classCodes);
		for (String code : classCodes) {
			Scan(code);
		}
	}

	public static void Scan(String classCode) throws Exception {
		JSONArray objectArray = DataDictQueryUtil_v2.getObjects(classCode, projectId, groupCode);
		Constant.warn(classCode + "\t" + objectArray.size());
		if (objectArray == null || objectArray.size() == 0) {
			return;
		}

		JSONArray infoArray = DataDictQueryUtil_v2.get_infos(classCode, projectId, groupCode);
		if (infoArray != null && objectArray != null) {
			JSONArray addInfoArray = new JSONArray();
			for (int i = 0; i < objectArray.size(); i++) {
				JSONObject object = (JSONObject) objectArray.get(i);
				String id = (String) object.get("id");
				String localId = (String) object.get("localId");
				String localName = (String) object.get("localName");
				JSONArray remove_infos = new JSONArray();
				JSONObject removeObj = new JSONObject();
				for (int ii = 0; ii < infoArray.size(); ii++) {
					JSONObject info = (JSONObject) infoArray.get(ii);
					String firstTag = (String) info.get("firstTag");
					String info_code = (String) info.get("code");
					if (firstTag == null) {
						continue;
					}
					if (firstTag.equals("в") || firstTag.equals("趨") || firstTag.equals("¼¼")) {
						Object info_value = object.get(info_code);
						if (info_value != null) {
							if (all_point) {
								removeObj.put(info_code, info_value);
								remove_infos.add(info_code);
							} else {
								if (info_value.toString().startsWith(classCode + "_")
										&& (info_value.toString().endsWith("_" + info_code + "-" + "901")
												|| info_value.toString().endsWith("_" + info_code + "-" + "902")
												|| info_value.toString().endsWith("_" + info_code + "-" + "903"))) {
									removeObj.put(info_code, info_value);
									remove_infos.add(info_code);
								}
							}
						}
					}
				}
				if (remove_infos.size() > 0) {
					Constant.warn(classCode + "\t" + id + "\t" + localId + "\t" + localName + "\t" + removeObj.toJSONString());
					JSONObject update_param = new JSONObject();
					update_param.put("id", id);
					update_param.put("$remove", remove_infos);
					if (!only_print) {
						addInfoArray.add(update_param);
						if (addInfoArray.size() >= 100) {
							updateArray(addInfoArray);
							addInfoArray.clear();
						}
					}
				}
			}
			if (addInfoArray.size() > 0) {
				updateArray(addInfoArray);
				addInfoArray.clear();
			}
		}
	}

	public static void updateArray(JSONArray postJSON) throws Exception {
		JSONObject classTree = JSON.parseObject(
				HttpUtil.Instance().post(Constant.data_middle_url + "rwd/instance/object/update?projectId=" + projectId + "&groupCode=" + groupCode,
						JSON.toJSONString(postJSON, SerializerFeature.WriteMapNullValue)));
		String result = (String) classTree.get("result");
		if (!result.equals("success")) {
			Constant.warn(result + "\t" + JSON.toJSONString(postJSON, SerializerFeature.WriteMapNullValue));
		}
	}

	public static void update1(JSONObject param) throws Exception {
		JSONArray postJSON = new JSONArray();
		postJSON.add(param);
		JSONObject classTree = JSON.parseObject(
				HttpUtil.Instance().post(Constant.data_middle_url + "rwd/instance/object/update?projectId=" + projectId + "&groupCode=" + groupCode,
						JSON.toJSONString(postJSON, SerializerFeature.WriteMapNullValue)));
		String result = (String) classTree.get("result");
		if (!result.equals("success")) {
			Constant.warn(result + "\t" + JSON.toJSONString(param, SerializerFeature.WriteMapNullValue));
		}
	}

	public static void update1(String id, String infoCode, Object infoValue) throws Exception {
		JSONArray param = new JSONArray();
		JSONObject criteria = new JSONObject();
		criteria.put("id", id);
		criteria.put(infoCode, infoValue);
		param.add(criteria);
		JSONObject classTree = JSON.parseObject(
				HttpUtil.Instance().post(Constant.data_middle_url + "rwd/instance/object/update?projectId=" + projectId + "&groupCode=" + groupCode,
						JSON.toJSONString(param, SerializerFeature.WriteMapNullValue)));
		String result = (String) classTree.get("result");
		if (!result.equals("success")) {
			Constant.warn(id + "\t" + infoCode + "\t" + infoValue + "\t" + result);
		}
	}

	public static void print(JSONArray dataArray, String propertyName) {
		Constant.warn(propertyName + " :");
		Map<String, Boolean> objTypeMap = new HashMap<String, Boolean>();
		for (int i = 0; i < dataArray.size(); i++) {
			JSONObject data = (JSONObject) dataArray.get(i);
			String objType = (String) data.get(propertyName);
			if (objType == null || objType.length() == 0) {
				continue;
			}
			if (!objTypeMap.containsKey(objType)) {
				objTypeMap.put(objType, true);
				Constant.warn(objType);
			}
		}
	}
}
