package com.persagy.data_dict_tool.v2;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.pbsage.util.Constant;
import com.pbsage.util.HttpUtil;

//heightλĳ
public class UpdateInfo {
	public static String mode = "generate";// generate/remove
	public static String projectId = "Pj4403070003";
	public static String groupCode = "WD";
	// public static String projectId = "Pj4403050019";
	// public static String groupCode = "ZS";
	public static boolean only_print = true;

	public static void main(String[] args) throws Exception {
		int index = 0;
		mode = args[index++];
		projectId = args[index++];
		groupCode = args[index++];
		only_print = args[index++].equalsIgnoreCase("true") ? true : false;

		Scan_dict();
	}

	public static void Scan_dict() throws Exception {
		JSONObject classParam = new JSONObject();
		JSONObject criteria = new JSONObject();
		criteria.put("objType", "floor");
		criteria.put("valid", 1);
		classParam.put("criteria", criteria);
		JSONObject classTree = JSON.parseObject(
				HttpUtil.Instance().post(Constant.data_middle_url + "rwd/instance/object/query?projectId=" + projectId + "&groupCode=" + groupCode,
						JSON.toJSONString(classParam, SerializerFeature.WriteMapNullValue)));
		JSONArray dataArray = (JSONArray) classTree.get("data");
		for (int i = 0; i < dataArray.size(); i++) {
			JSONObject data = (JSONObject) dataArray.get(i);
			String id = data.getString("id");
			Constant.warn(id);
			if (data.containsKey("height")) {
				String value = data.get("height").toString();
				double value_new = Double.parseDouble(value) / 1000.0;
				JSONObject add_infos = new JSONObject();
				add_infos.put("height", value_new);
				add_infos.put("id", id);
				if (only_print) {
					Constant.warn(add_infos.toJSONString());
				} else {
					Constant.warn(add_infos.toJSONString());
					update(add_infos);
				}
			}
		}
	}

	public static void update(JSONObject param) throws Exception {
		JSONArray postJSON = new JSONArray();
		postJSON.add(param);
		JSONObject classTree = JSON.parseObject(
				HttpUtil.Instance().post(Constant.data_middle_url + "rwd/instance/object/update?projectId=" + projectId + "&groupCode=" + groupCode,
						JSON.toJSONString(postJSON, SerializerFeature.WriteMapNullValue)));
		String result = (String) classTree.get("result");
		if (!result.equals("success")) {
			Constant.warn(result + "\t" + JSON.toJSONString(param, SerializerFeature.WriteMapNullValue));
		}
	}

	public static void update(String id, String infoCode, Object infoValue) throws Exception {
		JSONArray param = new JSONArray();
		JSONObject criteria = new JSONObject();
		criteria.put("id", id);
		criteria.put(infoCode, infoValue);
		param.add(criteria);
		JSONObject classTree = JSON.parseObject(
				HttpUtil.Instance().post(Constant.data_middle_url + "rwd/instance/object/update?projectId=" + projectId + "&groupCode=" + groupCode,
						JSON.toJSONString(param, SerializerFeature.WriteMapNullValue)));
		String result = (String) classTree.get("result");
		if (!result.equals("success")) {
			Constant.warn(id + "\t" + infoCode + "\t" + infoValue + "\t" + result);
		}
	}
}
