package com.persagy.util;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.data_dict_tool.DataDictQueryUtil;

@SuppressWarnings("unused")
public class DataDictUtil {
	public static boolean point_use_localId = true;
	public static int yunxing_index = 1;
	public static int sheding_index = 1;

	public static int getInfoType(JSONObject infoJSON) {
		String firstTag = infoJSON.get("firstTag") == null ? null : (String) infoJSON.get("firstTag");
		String secondTag = infoJSON.get("secondTag") == null ? null : (String) infoJSON.get("secondTag");
		if (firstTag != null) {
			if (firstTag.contains("в")) {
				return 1;
			} else if (firstTag.contains("¼¼")) {
				if (secondTag != null && secondTag.contains("Ϣ")) {
					return 1;
				} else {
					return 1;
				}
			} else if (firstTag.contains("趨")) {
				if (secondTag != null && secondTag.contains("趨ֵ")) {
					return 1;
				} else {
					return 2;
				}
			}
		}
		return 0;
	}

	public static Map<String, String> status_set(JSONArray infos) {
		Map<String, Boolean> statusMap = new HashMap<String, Boolean>();
		Map<String, Boolean> setMap = new HashMap<String, Boolean>();
		for (int ii = 0; ii < infos.size(); ii++) {
			JSONObject info = (JSONObject) infos.get(ii);
			String category = (String) info.get("category");
			String firstTag = (String) info.get("firstTag");
			String secondTag = (String) info.get("secondTag");
			String info_code = (String) info.get("code");
			if (DataDictUtil.getInfoType(info) == 1) {
				statusMap.put(info_code, true);
			} else if (DataDictUtil.getInfoType(info) == 2) {
				setMap.put(info_code, true);
			}
		}

		Map<String, String> result = new HashMap<String, String>();
		Iterator<String> keyIter = setMap.keySet().iterator();
		while (keyIter.hasNext()) {
			String key = keyIter.next();
			if (key.endsWith("Set") && statusMap.containsKey(key.substring(0, key.length() - "Set".length()))) {
				result.put(key.substring(0, key.length() - "Set".length()), key);
			} else if (key.endsWith("Set") && statusMap.containsKey(key.substring(0, key.length() - "Set".length()) + "Status")) {
				result.put(key.substring(0, key.length() - "Set".length()) + "Status", key);
			} else if (statusMap.containsKey(key + "Status")) {
				result.put(key + "Status", key);
			} else if (statusMap.containsKey(key + "Feedback")) {
				result.put(key + "Feedback", key);
			}
		}
		return result;
	}

	public static Map<String, SequenceNo> sequenceMap = new HashMap<String, SequenceNo>();

	public static int generateSequenceNo(String classCode) {
		if (!sequenceMap.containsKey(classCode)) {
			sequenceMap.put(classCode, new SequenceNo());
		}
		SequenceNo se = sequenceMap.get(classCode);
		return se.index++;
	}

	public static JSONObject createObject(String classCode, String localName) throws Exception {
		int sequenceNo = generateSequenceNo(classCode);
		JSONArray infos = DataDictQueryUtil.get_infos(classCode);
		JSONObject object = DataDictUtil.generateObject(classCode, sequenceNo, infos, localName);
		DataDictQueryUtil.insert_object(object);
		String id = DataDictQueryUtil.getIdByLocalId(classCode, sequenceNo);
		object.put("id", id);
		return object;
	}

	public static JSONObject generateObject(String classCode, int sequenceNo, JSONArray infos, String localName) throws Exception {
		JSONObject result = new JSONObject();
		result.put("classCode", classCode);
		for (int i = 0; i < infos.size(); i++) {
			JSONObject info = (JSONObject) infos.get(i);
			String firstTag = (String) info.get("firstTag");
			String category = (String) info.get("category");
			String code = (String) info.get("code");
			String name = (String) info.get("name");
			String dataType = (String) info.get("dataType");

			Object infoValue = null;
			if (category.equals("STATIC")) {
				if (firstTag == null) {
					if (code.equals("id")) {
						// infoValue = classCode + "_" + code + "_" + sequenceNo;
					} else if (code.equals("name")) {
						infoValue = classCode + "_" + sequenceNo;
					} else if (code.equals("localId")) {
						infoValue = classCode + "_" + sequenceNo;
					} else if (code.equals("localName")) {
						if (localName == null) {
							infoValue = classCode + "_" + sequenceNo;
						} else {
							infoValue = localName;
						}
					} else if (code.endsWith("ID")) {
						infoValue = classCode + "_" + sequenceNo;
					} else if (code.endsWith("Name")) {
						infoValue = classCode + "_" + sequenceNo;
					} else {
						// throw new Exception("firstTag: " + firstTag + "\t" + "code: " + code);
					}
				} else {
					if (firstTag.equals("Ϣ") || firstTag.equals("") || firstTag.equals("") || firstTag.equals("-ͨ")) {
						infoValue = generateInfo(info, dataType);
					}
				}
			} else if (DataDictUtil.getInfoType(info) == 1) {
				infoValue = (point_use_localId ? classCode + "_" + sequenceNo : "" + yunxing_index++) + "_" + code + "-" + 901;
			} else if (DataDictUtil.getInfoType(info) == 2) {
				infoValue = (point_use_localId ? classCode + "_" + sequenceNo : "" + sheding_index++) + "_" + code + "-" + 903;
			} else {
				// throw new Exception("firstTag: " + firstTag + "\t" + "category: " + category);
			}

			if (infoValue != null) {
				result.put(code, infoValue);
			}
		}
		return result;
	}

	private static Object generateInfo(JSONObject info, String dataType) {
		Object result = null;
		Boolean isMultiple = (Boolean) info.get("isMultiple");
		Boolean isRegion = (Boolean) info.get("isRegion");
		if (!isMultiple && !isRegion) {
			if (dataType.equals("INTEGER")) {
				result = "" + 2;
			} else if (dataType.equals("DOUBLE")) {
				result = "" + 5.20;
			} else if (dataType.equals("BOOLEAN")) {
				result = "" + true;
			} else if (dataType.equals("STRING")) {
				result = "" + "a";
			} else if (dataType.equals("ENUM")) {
				// result = "" + 1;
			} else if (dataType.equals("MENUM")) {
				// result = "[1, 2]";
			}
		} else if (isRegion) {
			// if (dataType.equals("INTEGER")) {
			// result = "1, 2";
			// } else if (dataType.equals("DOUBLE")) {
			// result = "1.2, 3.4";
			// }
		}
		return result;
	}
}
