package com.persagy.zkt_tool;

import java.util.HashMap;
import java.util.Map;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.pbsage.util.Constant;
import com.pbsage.util.HttpUtil;
import com.persagy.util.DataDictUtil;
import com.persagy.util.ExcelSheet;
import com.persagy.util.ExcelUtil;

public class ZKTAlarmMain {
	public static String url_dict = "http://39.102.54.110:8082/";
	public static String url = "http://39.102.43.179:9983/";
	public static String url_alarm = "http://39.102.54.110:8083/";
	public static String appId = "zkt";
	public static String projectId = "Pj4403070003";
	public static String groupCode = "WD";
	// public static String projectId = "Pj4403050019";
	// public static String groupCode = "ZS";

	public static Map<String, Map<String, Boolean>> systemMapMap = new HashMap<String, Map<String, Boolean>>();
	public static Map<String, Map<String, Boolean>> equipmentMapMap = new HashMap<String, Map<String, Boolean>>();

	public static String[] codeNames = { "߱", "б", "ϱ", "ȼ屨", "Ŵſع", "ŵ綯", "ŵ綯", "±", "±", "±", "±",
			"ˮѹƫ", "ˮѹƫ", "ˮѹƫ", "ط¶ƫ", "ط¶ƫ" };
	public static String[] alarm_categorys = { "߱", "б", "ϱ", "ȼ屨", "Ŵſع", "ŵ綯", "ŵ綯", "±", "±", "±",
			"±", "ˮѹƫ", "ˮѹƫ", "ˮѹƫ", "ط¶ƫ", "ط¶ƫ" };
	public static String[] item_codes = { "1005", "1007", "1008", "1040", "1041", "1042", "1043", "1044", "1045", "1046", "1047", "1048", "1049",
			"1050", "1051", "1052" };
	public static String[] infos = { "onlineStatus", "runStatus", "faultStatus", "indoorAirH", "indoorAirCO2", "outdoorAirH", "freshAirValveOpening",
			"returnAirTemp", "returnAirRH", "returnAirValveOpening", "chillWaterOutTemp", "waterInOutDetaPress", "chillWaterValveOpening",
			"supplyAirTemp", "fanFreq", "insulationValveStatus" };
	public static int[] triggerUpholds = { 0, 0, 0, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10 };
	public static int[] endUpholds = { 0, 0, 0, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5 };
	public static Map<String, Integer> infoIndexMap = new HashMap<String, Integer>();

	@SuppressWarnings("unused")
	public static void main(String[] args) throws Exception {
		ExcelSheet ExcelSheet = ExcelUtil.ReadSheet(Constant.GetPath() + "/info_code.xlsx", "Sheet1", true);
		for (int i = 0; i < ExcelSheet.contentListList.size(); i++) {
			String content1 = ExcelUtil.getContentInner(ExcelSheet, 5, i);
			String content3 = ExcelUtil.getContentInner(ExcelSheet, 7, i);
			String content5 = ExcelUtil.getContentInner(ExcelSheet, 10, i);
			if (content1 == null || content5 == null) {
				continue;
			}
			if (content3 == null || content3.length() == 0) {
				if (!systemMapMap.containsKey(content1)) {
					systemMapMap.put(content1, new HashMap<String, Boolean>());
				}
				systemMapMap.get(content1).put(content5.toLowerCase(), true);
			} else {
				if (!equipmentMapMap.containsKey(content3)) {
					equipmentMapMap.put(content3, new HashMap<String, Boolean>());
				}
				equipmentMapMap.get(content3).put(content5.toLowerCase(), true);
			}
		}
		{
			for (int i = 0; i < infos.length; i++) {
				infoIndexMap.put(infos[i], i);
			}
		}
		{
			JSONArray dataArray;
			{
				JSONObject classParam = new JSONObject();
				classParam.put("criteria", new JSONObject());
				JSONObject classTree = JSON
						.parseObject(HttpUtil.Instance().post(url_dict + "rwd/def/class?projectId=" + projectId + "&groupCode=" + groupCode,
								JSON.toJSONString(classParam, SerializerFeature.WriteMapNullValue)));
				dataArray = (JSONArray) classTree.get("data");
			}

			for (int i = 0; i < dataArray.size(); i++) {
				JSONObject data = (JSONObject) dataArray.get(i);
				String objType = (String) data.get("objType");
				if (objType == null || objType.length() == 0) {
					continue;
				}
				String majorCode = (String) data.get("majorCode");
				if (majorCode == null || majorCode.length() == 0) {
					continue;
				}
				if (objType.equals("system") || objType.equals("equipment")) {
					String code = (String) data.get("code");
					if (code.equals("FFFSSN")) {
						continue;
					}
					// if (!majorCode.equals("AC")) {
					// continue;
					// }

					JSONArray objectArray = null;
					{
						JSONObject criteria = new JSONObject();
						criteria.put("classCode", code);
						JSONObject classParam = new JSONObject();
						classParam.put("criteria", criteria);
						JSONObject classTree = JSON.parseObject(
								HttpUtil.Instance().post(url_dict + "rwd/instance/object/query?projectId=" + projectId + "&groupCode=" + groupCode,
										JSON.toJSONString(classParam, SerializerFeature.WriteMapNullValue)));
						objectArray = (JSONArray) classTree.get("data");
						if (objectArray == null) {
							objectArray = new JSONArray();
						}
					}

					{
						JSONObject criteria = new JSONObject();
						criteria.put("classCode", code);
						JSONObject classParam = new JSONObject();
						classParam.put("criteria", criteria);
						JSONObject classTree = JSON
								.parseObject(HttpUtil.Instance().post(url_dict + "rwd/def/funcid?projectId=" + projectId + "&groupCode=" + groupCode,
										JSON.toJSONString(classParam, SerializerFeature.WriteMapNullValue)));
						JSONArray dataArrayInner = (JSONArray) classTree.get("data");
						if (dataArrayInner != null && objectArray != null) {
							String classCode = code;
							for (int ii = 0; ii < dataArrayInner.size(); ii++) {
								JSONObject info = (JSONObject) dataArrayInner.get(ii);
								String info_code = (String) info.get("code");

								boolean valid = false;
								if (classCode.length() == 4) {
									if (systemMapMap.containsKey(classCode.substring(2))
											&& systemMapMap.get(classCode.substring(2)).containsKey(info_code.toLowerCase())) {
										valid = true;
									}
								} else if (classCode.length() == 6) {
									if (equipmentMapMap.containsKey(classCode.substring(2))
											&& equipmentMapMap.get(classCode.substring(2)).containsKey(info_code.toLowerCase())) {
										valid = true;
									}
								}
								if (!valid) {
									continue;
								}

								boolean is_run_param = false;
								if (DataDictUtil.getInfoType(info) == 1) {
									is_run_param = true;
								} else if (DataDictUtil.getInfoType(info) == 2) {
								}
								if (!is_run_param) {
									continue;
								}

								if (!infoIndexMap.containsKey(info_code)) {
									continue;
								}

								String item_code = item_codes[infoIndexMap.get(info_code)];
								String alarm_category = alarm_categorys[infoIndexMap.get(info_code)];
								int triggerUphold = triggerUpholds[infoIndexMap.get(info_code)];
								int endUphold = endUpholds[infoIndexMap.get(info_code)];
								// alarm_target
								if (true) {
									JSONObject criteriaInner = new JSONObject();
									criteriaInner.put("itemCode", item_code);
									criteriaInner.put("classCode", code);
									criteriaInner.put("concern", 0);
									criteriaInner.put("open", 0);
									criteriaInner.put("condition", condition(info_code, triggerUphold, endUphold));
									JSONObject result = JSON
											.parseObject(HttpUtil.Instance()
													.post(url_alarm + "alarm/target/create?userId=System&groupCode=" + groupCode + "&projectId="
															+ projectId + "&appId=" + appId,
															JSON.toJSONString(criteriaInner, SerializerFeature.WriteMapNullValue)));
									Constant.warn(result.toJSONString());
								}

								for (int index = 0; index < objectArray.size(); index++) {
									JSONObject object = (JSONObject) objectArray.get(index);
									String id = (String) object.get("id");

									Object info_value = object.get(info_code);
									if (false && info_value != null) {
										JSONObject criteriaInner = new JSONObject();
										criteriaInner.put("appId", appId);
										criteriaInner.put("projectId", projectId);
										criteriaInner.put("userId", "System");
										criteriaInner.put("groupCode", groupCode);
										criteriaInner.put("userDefined", "0");
										criteriaInner.put("objId", id);
										criteriaInner.put("itemCode", item_code);
										criteriaInner.put("category", alarm_category);
										criteriaInner.put("level", "S");
										criteriaInner.put("open", 0);
										criteriaInner.put("condition", condition(info_code, triggerUphold, endUphold));
										JSONObject result = JSON.parseObject(HttpUtil.Instance().post(url + "alarm/updateConfig",
												JSON.toJSONString(criteriaInner, SerializerFeature.WriteMapNullValue)));
										Constant.warn(result.toJSONString());
									}
								}
							}
						}
					}
				}
			}
		}
	}

	public static JSONObject condition(String info, int triggerUphold, int endUphold) {
		JSONObject result = new JSONObject();
		JSONArray infoCode = new JSONArray();
		infoCode.add(info);
		result.put("infoCode", infoCode);
		result.put("trigger", info + ">" + 0.5);
		result.put("end", info + "<" + 0.5);
		result.put("triggerUphold", triggerUphold);
		result.put("endUphold", endUphold);
		JSONObject time = new JSONObject();
		time.put("type", "period");
		JSONObject period = new JSONObject();
		period.put("$gt", "090000");
		period.put("$lt", "210000");
		time.put("period", period);
		result.put("time", time);
		return result;
	}
}
