package com.persagy.zkt_tool;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.pbsage.util.Constant;
import com.pbsage.util.HttpUtil;

public class ZKTControlMain {
	public static String url_dict = "http://39.102.54.110:8082/";
	public static String url = "http://39.102.43.179:9980/";
	public static String appId = "zkt-control";
	// public static String projectId = "Pj4403070003";
	// public static String groupCode = "WD";
	public static String projectId = "Pj4403050019";
	public static String groupCode = "ZS";

	public static Map<Integer, JSONObject> tabMap = new HashMap<Integer, JSONObject>();
	public static Map<Integer, Map<String, JSONObject>> tab2ObjTypeMap = new HashMap<Integer, Map<String, JSONObject>>();
	public static Map<String, Map<String, JSONObject>> ObjType2Infos = new HashMap<String, Map<String, JSONObject>>();

	public static void main(String[] args) throws Exception {
		{
			JSONObject criteria = new JSONObject();
			criteria.put("appId", appId);
			criteria.put("projectId", projectId);
			JSONObject result = JSON.parseObject(
					HttpUtil.Instance().post(url + "control_tab/query", JSON.toJSONString(criteria, SerializerFeature.WriteMapNullValue)));
			JSONArray Content = (JSONArray) result.get("Content");
			for (int i = 0; i < Content.size(); i++) {
				JSONObject tab = (JSONObject) Content.get(i);
				int tabId = (Integer) tab.get("tabId");
				tabMap.put(tabId, tab);

				JSONObject criteriaInner = new JSONObject();
				criteriaInner.put("appId", appId);
				criteriaInner.put("projectId", projectId);
				criteriaInner.put("tabId", tabId);
				JSONObject resultInner = JSON.parseObject(HttpUtil.Instance().post(url + "model/equip_type/query",
						JSON.toJSONString(criteriaInner, SerializerFeature.WriteMapNullValue)));
				JSONArray ContentInner = (JSONArray) resultInner.get("Content");
				Map<String, JSONObject> eqtype = new HashMap<String, JSONObject>();
				for (int ii = 0; ii < ContentInner.size(); ii++) {
					JSONObject itemInner = (JSONObject) ContentInner.get(ii);
					String equipTypeId = (String) itemInner.get("equipTypeId");
					eqtype.put(equipTypeId, itemInner);

					if (!ObjType2Infos.containsKey(equipTypeId)) {
						JSONObject criteriaInner2 = new JSONObject();
						criteriaInner2.put("appId", appId);
						criteriaInner2.put("projectId", projectId);
						criteriaInner2.put("equipTypeId", equipTypeId);
						JSONObject resultInner2 = JSON.parseObject(
								HttpUtil.Instance().post(url + "info/query", JSON.toJSONString(criteriaInner2, SerializerFeature.WriteMapNullValue)));
						JSONArray ContentInner2 = (JSONArray) resultInner2.get("Content");
						Map<String, JSONObject> infos = new HashMap<String, JSONObject>();
						for (int iii = 0; iii < ContentInner2.size(); iii++) {
							JSONObject itemInner2 = (JSONObject) ContentInner2.get(iii);
							String infoId = (String) itemInner2.get("infoId");
							infos.put(infoId, itemInner2);
						}
						ObjType2Infos.put(equipTypeId, infos);
					}
				}
				tab2ObjTypeMap.put(tabId, eqtype);
			}
		}

		Create_mode();

		Create_plan();

		Bind_equip();

		Bind_calendar("20201101", "20201130");
	}

	public static void Create_mode() throws Exception {
		int index_color = 1;
		Integer[] tabIds = tabMap.keySet().toArray(new Integer[0]);
		for (Integer tabId : tabIds) {
			for (int i = 0; i < 1; i++) {
				JSONObject criteria = new JSONObject();
				criteria.put("appId", appId);
				criteria.put("projectId", projectId);
				criteria.put("tabId", tabId);
				criteria.put("name", "name" + "-" + tabId + "-" + (i + 1));
				criteria.put("color", "color" + "-" + (index_color++));
				criteria.put("modelOrder", i);
				JSONObject result = JSON.parseObject(
						HttpUtil.Instance().post(url + "model/create", JSON.toJSONString(criteria, SerializerFeature.WriteMapNullValue)));
				Constant.warn(result.toJSONString());
			}
		}
	}

	public static void Create_plan() throws Exception {
		DecimalFormat df = new DecimalFormat("00");
		Integer[] tabIds = tabMap.keySet().toArray(new Integer[0]);
		for (Integer tabId : tabIds) {
			Map<String, JSONObject> ObjTypeMap = tab2ObjTypeMap.get(tabId);
			JSONObject criteria = new JSONObject();
			criteria.put("appId", appId);
			criteria.put("projectId", projectId);
			criteria.put("tabId", tabId);
			JSONObject result = JSON
					.parseObject(HttpUtil.Instance().post(url + "model/query", JSON.toJSONString(criteria, SerializerFeature.WriteMapNullValue)));
			JSONArray Content = (JSONArray) result.get("Content");
			if (Content == null) {
				Content = new JSONArray();
			}
			for (int i = 0; i < Content.size(); i++) {
				JSONObject tab = (JSONObject) Content.get(i);
				String id = (String) tab.get("id");
				String name = (String) tab.get("name");
				if (!name.startsWith("name" + "-")) {
					continue;
				}

				for (String ObjType : ObjTypeMap.keySet().toArray(new String[0])) {
					String[] infos = ObjType2Infos.get(ObjType).keySet().toArray(new String[0]);
					JSONObject criteria_plan = new JSONObject();
					criteria_plan.put("appId", appId);
					criteria_plan.put("projectId", projectId);
					criteria_plan.put("modelId", id);
					criteria_plan.put("equipType", ObjType);
					criteria_plan.put("tabGroup", 0);
					criteria_plan.put("name", ObjType);
					criteria_plan.put("planOrder", 0);
					JSONArray detail = new JSONArray();
					int value = 1;
					for (int index_time = 600; index_time < 1320; index_time += 60) {
						int minute = index_time % 60;
						int hour = index_time / 60;
						String time = df.format(hour) + df.format(minute) + "00";
						JSONObject detailItem = new JSONObject();
						detailItem.put("timeType", 1);
						detailItem.put("name", time);
						detailItem.put("absoluteTime", time);
						detailItem.put("offset", 0);
						detailItem.put("detailOrder", 0);
						JSONArray actions = new JSONArray();
						for (String info : infos) {
							JSONObject action = new JSONObject();
							action.put("code", info);
							action.put("name", info);
							action.put("value", value);
							actions.add(action);
						}
						detailItem.put("actions", actions);
						detail.add(detailItem);
						value++;
						value %= 2;
					}
					criteria_plan.put("detail", detail);

					JSONObject resultInner = JSON.parseObject(
							HttpUtil.Instance().post(url + "plan/create", JSON.toJSONString(criteria_plan, SerializerFeature.WriteMapNullValue)));
					Constant.warn(resultInner.toJSONString());
				}
			}
		}
	}

	public static void Bind_equip() throws Exception {
		Integer[] tabIds = tabMap.keySet().toArray(new Integer[0]);
		for (Integer tabId : tabIds) {
			Map<String, JSONObject> ObjTypeMap = tab2ObjTypeMap.get(tabId);
			JSONObject criteria = new JSONObject();
			criteria.put("appId", appId);
			criteria.put("projectId", projectId);
			criteria.put("tabId", tabId);
			JSONObject result = JSON
					.parseObject(HttpUtil.Instance().post(url + "model/query", JSON.toJSONString(criteria, SerializerFeature.WriteMapNullValue)));
			JSONArray Content = (JSONArray) result.get("Content");
			if (Content == null) {
				Content = new JSONArray();
			}
			for (int i = 0; i < Content.size(); i++) {
				JSONObject tab = (JSONObject) Content.get(i);
				String id = (String) tab.get("id");
				String name = (String) tab.get("name");
				if (!name.startsWith("name" + "-")) {
					continue;
				}

				for (String ObjType : ObjTypeMap.keySet().toArray(new String[0])) {
					JSONObject criteriaInner = new JSONObject();
					criteriaInner.put("classCode", ObjType);
					JSONObject paramInner = new JSONObject();
					paramInner.put("criteria", criteriaInner);
					JSONObject equipmentsResult = JSON.parseObject(
							HttpUtil.Instance().post(url_dict + "rwd/instance/object/query?projectId=" + projectId + "&groupCode=" + groupCode,
									JSON.toJSONString(paramInner, SerializerFeature.WriteMapNullValue)));
					JSONArray equipments = (JSONArray) equipmentsResult.get("data");
					if (equipments == null) {
						equipments = new JSONArray();
					}

					JSONObject criteria_plan = new JSONObject();
					criteria_plan.put("appId", appId);
					criteria_plan.put("projectId", projectId);
					criteria_plan.put("modelId", id);
					criteria_plan.put("equipType", ObjType);
					JSONObject resultInner = JSON.parseObject(
							HttpUtil.Instance().post(url + "plan/query", JSON.toJSONString(criteria_plan, SerializerFeature.WriteMapNullValue)));
					JSONArray ContentInner = (JSONArray) resultInner.get("Content");
					for (int ii = 0; ii < ContentInner.size(); ii++) {
						JSONObject plan = (JSONObject) ContentInner.get(ii);
						String planId = (String) plan.get("id");
						JSONArray binding = new JSONArray();
						for (int iii = 0; iii < equipments.size(); iii++) {
							JSONObject equipment = (JSONObject) equipments.get(iii);
							String equipId = (String) equipment.get("id");
							JSONObject bindingItem = new JSONObject();
							bindingItem.put("planId", planId);
							bindingItem.put("equipId", equipId);
							binding.add(bindingItem);
						}
						JSONObject paramBinding = new JSONObject();
						paramBinding.put("appId", appId);
						paramBinding.put("projectId", projectId);
						paramBinding.put("modelId", id);
						paramBinding.put("binding", binding);
						JSONObject bindingResult = JSON.parseObject(HttpUtil.Instance().post(url + "plan/equip/binding",
								JSON.toJSONString(paramBinding, SerializerFeature.WriteMapNullValue)));
						Constant.warn(bindingResult.toJSONString());
					}
				}
			}
		}
	}

	public static void Bind_calendar(String string_from, String string_to) throws Exception {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
		Date date_from = sdf.parse(string_from);
		Date date_to = sdf.parse(string_to);
		JSONArray date = new JSONArray();
		for (Date tmp = date_from; tmp.getTime() <= date_to.getTime(); tmp = new Date(tmp.getTime() + 1000L * 60 * 60 * 24)) {
			date.add(sdf.format(tmp));
		}
		Integer[] tabIds = tabMap.keySet().toArray(new Integer[0]);
		for (Integer tabId : tabIds) {
			JSONObject criteria = new JSONObject();
			criteria.put("appId", appId);
			criteria.put("projectId", projectId);
			criteria.put("tabId", tabId);
			JSONObject result = JSON
					.parseObject(HttpUtil.Instance().post(url + "model/query", JSON.toJSONString(criteria, SerializerFeature.WriteMapNullValue)));
			JSONArray Content = (JSONArray) result.get("Content");
			if (Content == null) {
				Content = new JSONArray();
			}
			String first_id = null;
			for (int i = 0; i < Content.size(); i++) {
				JSONObject tab = (JSONObject) Content.get(i);
				String id = (String) tab.get("id");
				String name = (String) tab.get("name");
				if (!name.startsWith("name" + "-")) {
					continue;
				}
				first_id = id;
				break;
			}

			JSONObject criteriaInner = new JSONObject();
			criteriaInner.put("appId", appId);
			criteriaInner.put("projectId", projectId);
			criteriaInner.put("date", date);
			JSONArray model = new JSONArray();
			JSONObject modelItem = new JSONObject();
			modelItem.put("tabId", tabId);
			modelItem.put("modelId", first_id);
			model.add(modelItem);
			criteriaInner.put("model", model);
			JSONObject resultInner = JSON.parseObject(
					HttpUtil.Instance().post(url + "calendar/model/binding", JSON.toJSONString(criteriaInner, SerializerFeature.WriteMapNullValue)));
			Constant.warn(resultInner.toJSONString());
		}
	}
}
