package com.persagy.data_dict_tool;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.pbsage.util.Constant;
import com.pbsage.util.HttpUtil;

public class DataDictQueryUtil {

	public static JSONArray get_infos(String classCode) throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("type", "common");
		criteria.put("classCode", classCode);
		JSONObject param = new JSONObject();
		param.put("criteria", criteria);
		String paramString = JSON.toJSONString(param, SerializerFeature.WriteMapNullValue);
		// Constant.warn(paramString);
		String full_url_2 = DataDictToolMain.url + "dict/funcid/query" + DataDictToolMain.url_param;
		JSONObject queryResult = JSON.parseObject(HttpUtil.Instance().post(full_url_2, paramString));
		JSONArray infos = (JSONArray) queryResult.get("data");

		return infos;
	}

	public static void insert_rel(String graphId, String rel, String from, String to) throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("graphId", graphId);
		criteria.put("rel", rel);
		criteria.put("from", from);
		criteria.put("to", to);
		JSONArray paramArray = new JSONArray();
		paramArray.add(criteria);
		String paramString2 = JSON.toJSONString(paramArray, SerializerFeature.WriteMapNullValue);
		// Constant.warn(paramString);
		String full_url_2 = DataDictToolMain.url + "world/relation/save" + DataDictToolMain.url_param;
		JSONObject queryResult2 = JSON.parseObject(HttpUtil.Instance().post(full_url_2, paramString2));
		Constant.warn("insert_rel: " + JSON.toJSONString(queryResult2, SerializerFeature.WriteMapNullValue));
		if (!queryResult2.get("result").equals("success")) {
			throw new Exception(full_url_2 + "\n" + paramString2);
		}
	}

	public static void insert_object(JSONObject object) throws Exception {
		JSONArray paramArray = new JSONArray();
		paramArray.add(object);
		String paramString2 = JSON.toJSONString(paramArray, SerializerFeature.WriteMapNullValue);
		String full_url_2 = DataDictToolMain.url + "world/object/create" + DataDictToolMain.url_param;
		JSONObject queryResult2 = JSON.parseObject(HttpUtil.Instance().post(full_url_2, paramString2));
		Constant.warn("insert_object: " + JSON.toJSONString(queryResult2, SerializerFeature.WriteMapNullValue));
		if (!queryResult2.get("result").equals("success")) {
			throw new Exception(full_url_2 + "\n" + paramString2);
		}
	}

	public static String getIdByLocalId(String classCode, int sequenceNo) throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("classCode", classCode);
		criteria.put("localId", classCode + "_" + sequenceNo);
		JSONObject param = new JSONObject();
		param.put("criteria", criteria);
		String paramString2 = JSON.toJSONString(param, SerializerFeature.WriteMapNullValue);
		String full_url_2 = DataDictToolMain.url + "world/object/query" + DataDictToolMain.url_param;
		JSONObject queryResult2 = JSON.parseObject(HttpUtil.Instance().post(full_url_2, paramString2));
		JSONArray dataArray = (JSONArray) queryResult2.get("data");
		// Constant.warn(JSON.toJSONString(queryResult2, SerializerFeature.WriteMapNullValue));
		JSONObject data = (JSONObject) dataArray.get(0);
		String id = (String) data.get("id");
		return id;
	}

	public static JSONArray getObjects(String classCode) throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("classCode", classCode);
		JSONObject param = new JSONObject();
		param.put("criteria", criteria);
		String paramString2 = JSON.toJSONString(param, SerializerFeature.WriteMapNullValue);
		String full_url_2 = DataDictToolMain.url + "world/object/query" + DataDictToolMain.url_param;
		JSONObject queryResult2 = JSON.parseObject(HttpUtil.Instance().post(full_url_2, paramString2));
		JSONArray dataArray = (JSONArray) queryResult2.get("data");
		// Constant.warn(JSON.toJSONString(queryResult2, SerializerFeature.WriteMapNullValue));
		return dataArray;
	}
}
